release.macx.sh 5.2 KB
Newer Older
Claudio Valerio's avatar
Claudio Valerio committed
1
#!/bin/bash
Claudio Valerio's avatar
Claudio Valerio committed
2 3 4 5 6 7 8 9 10 11 12 13 14 15 16
# --------------------------------------------------------------------
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# ---------------------------------------------------------------------

Claudio Valerio's avatar
Claudio Valerio committed
17
# Executables
18
QMAKE="/usr/local/Trolltech/Qt-4.7.3/bin/qmake"
Claudio Valerio's avatar
Claudio Valerio committed
19
MACDEPLOYQT=/usr/local/Trolltech/Qt-4.7.3/bin/macdeployqt
20
DMGUTIL="`pwd`/../Sankore-ThirdParty/refnum/dmgutil/dmgutil.pl"
Claudio Valerio's avatar
Claudio Valerio committed
21 22 23
DSYMUTIL=/usr/bin/dsymutil
STRIP=/usr/bin/strip
PLISTBUDDY=/usr/libexec/PlistBuddy
Claudio Valerio's avatar
Claudio Valerio committed
24
ICEBERG=/usr/local/bin/freeze
Claudio Valerio's avatar
Claudio Valerio committed
25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70

# Directories
BUILD_DIR="build/macx/release"
PRODUCT_DIR="$BUILD_DIR/product"

function notify {
    GROWLNOTIFY=`which growlnotify`
    if [ -x "$GROWLNOTIFY" ]; then
        $GROWLNOTIFY --name uniboard-build --iconpath /Developer/Applications/Xcode.app --message "$1" "Uniboard"
    fi
    printf "\033[32m--->\033[0m $1\n"
}

function abort {
    printf "\033[31merror:\033[0m $1\n"
    exit 1
}

function warn {
    abort "$1"
}

function checkExecutable {
    if [ ! -x "$1" ]; then
        abort "$1 not found"
    fi
}

trap "defaults write com.mnemis.Uniboard.release Running -bool NO" EXIT

notify "Running Uniboard release script (`date`)"

script_is_running=`defaults read com.mnemis.Uniboard.release Running 2>/dev/null`
if [[ $? -eq 0 ]] && [[ "$script_is_running" = "1" ]]; then
    trap EXIT
    abort "another release script already running"
fi
defaults write com.mnemis.Uniboard.release Running -bool YES

# Check for executables
checkExecutable "$QMAKE"
checkExecutable "$MACDEPLOYQT"
checkExecutable "$DMGUTIL"
checkExecutable "$DSYMUTIL"
checkExecutable "$STRIP"
checkExecutable "$PLISTBUDDY"
Claudio Valerio's avatar
Claudio Valerio committed
71
checkExecutable "$ICEBERG"
Claudio Valerio's avatar
Claudio Valerio committed
72 73 74 75 76 77 78 79 80


# delete the build directory
notify "Cleaning ..."
rm -rf "$BUILD_DIR"

# generate Makefiles
notify "Generating Makefile ..."

shibakaneki's avatar
shibakaneki committed
81
QMAKE_CMD="$QMAKE -spec macx-g++"
Claudio Valerio's avatar
Claudio Valerio committed
82 83 84

$QMAKE_CMD

shibakaneki's avatar
shibakaneki committed
85 86 87 88
# build
notify "Compiling ..."
make -j4 release

Claudio Valerio's avatar
Claudio Valerio committed
89
VERSION=`cat "$BUILD_DIR/version"`
shibakaneki's avatar
shibakaneki committed
90
if [ ! -f "$BUILD_DIR/version" ]; then
91 92 93 94 95 96
    echo "version not found"
    exit 1
else
    LAST_COMMITED_VERSION="`git describe $(git rev-list --tags --max-count=1)`"
    if [ "v$VERSION" != "$LAST_COMMITED_VERSION" ]; then
	echo creating a tag with the version $VERSION
shibakaneki's avatar
shibakaneki committed
97
	git tag -a "v$VERSION" -m "Generated setup for v$VERSION"
98 99
	git push origin --tags
    fi
Claudio Valerio's avatar
Claudio Valerio committed
100
fi
101
  
Claudio Valerio's avatar
Claudio Valerio committed
102 103 104
#if [ $? != 0 ]; then
#    abort "compilation failed"
#fi
Claudio Valerio's avatar
Claudio Valerio committed
105 106


Claudio Valerio's avatar
Claudio Valerio committed
107
NAME="Open-Sankore"
Claudio Valerio's avatar
Claudio Valerio committed
108 109 110

DMG="$NAME.dmg"
VOLUME="/Volumes/$NAME"
Claudio Valerio's avatar
Claudio Valerio committed
111
APP="$PRODUCT_DIR/Open-Sankore.app"
Claudio Valerio's avatar
Claudio Valerio committed
112 113 114 115 116 117 118 119 120 121 122
DSYM_NAME="$NAME (r$SVN_REVISION).dSYM"
DSYM="$PRODUCT_DIR/$DSYM_NAME"
GSYM_i386="$PRODUCT_DIR/$NAME i386.sym"
INFO_PLIST="$APP/Contents/Info.plist"

rm -f "$APP/Contents/Resources/empty.lproj"

notify "Removing .svn directories ..."
find "$APP" -name .svn -exec rm -rf {} \; 2> /dev/null

# set various version infomration in Info.plist
Claudio Valerio's avatar
Claudio Valerio committed
123
$PLISTBUDDY -c "Set :CFBundleVersion $VERSION" "$INFO_PLIST"
Claudio Valerio's avatar
Claudio Valerio committed
124 125 126 127 128
$PLISTBUDDY -c "Set :CFBundleShortVersionString $VERSION" "$INFO_PLIST"
$PLISTBUDDY -c "Set :CFBundleGetInfoString $NAME" "$INFO_PLIST"

# bundle Qt Frameworks into the app bundle
notify "Bulding frameworks ..."
Claudio Valerio's avatar
Claudio Valerio committed
129 130 131
cd "`pwd`/build/macx/release/product/"
$MACDEPLOYQT "`pwd`/Open-Sankore.app"
cd -
Claudio Valerio's avatar
Claudio Valerio committed
132 133

notify "Extracting debug information ..."
Claudio Valerio's avatar
Claudio Valerio committed
134 135
$DSYMUTIL "$APP/Contents/MacOS/Open-Sankore" -o "$DSYM"
$STRIP -S "$APP/Contents/MacOS/Open-Sankore"
Claudio Valerio's avatar
Claudio Valerio committed
136

Claudio Valerio's avatar
Claudio Valerio committed
137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154
if [ "$1" == "pkg" ]; then
    ICEBERG_CONFIG_FILE="Open-Sankore.packproj"
    # set version information
    $PLISTBUDDY -c "Set :Hierarchy:Attributes:Settings:Description:International:IFPkgDescriptionVersion $VERSION" "$ICEBERG_CONFIG_FILE"
    $PLISTBUDDY -c "Set :Hierarchy:Attributes:Settings:Display\ Information:CFBundleShortVersionString $VERSION" "$ICEBERG_CONFIG_FILE"
    $PLISTBUDDY -c "Set :Hierarchy:Attributes:Settings:Version:IFMajorVersion `echo $VERSION | awk 'BEGIN { FS = "." }; { print $1 }'`" "$ICEBERG_CONFIG_FILE"
    $PLISTBUDDY -c "Set :Hierarchy:Attributes:Settings:Version:IFMinorVersion `echo $VERSION | awk 'BEGIN { FS = "." }; { print $2 }'`" "$ICEBERG_CONFIG_FILE"


    PRODUCT_DIR="install/mac/"

    if [ ! -d "${PRODUCT_DIR}" ]; then
	mkdir -p "${PRODUCT_DIR}"
    fi
    $ICEBERG $ICEBERG_CONFIG_FILE 
    exit 0
fi

Claudio Valerio's avatar
Claudio Valerio committed
155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180
notify "Creating dmg ..."
umount "$VOLUME" 2> /dev/null
$DMGUTIL --open --volume="$NAME" "$DMG"

cp -R "$APP" "$VOLUME"
ln -s /Applications "$VOLUME"

$DMGUTIL --set --iconsize=96 --toolbar=false --icon=resources/macx/UniboardDmg.icns "$VOLUME"
$DMGUTIL --set --x=20 --y=60 --width=580 --height=312 "$VOLUME"
$DMGUTIL --set --x=180 --y=160 "$VOLUME/`basename \"$APP\"`"
$DMGUTIL --set --x=400 --y=160 "$VOLUME/Applications"

$DMGUTIL --close --volume="$NAME" "$DMG"

notify "$NAME is built"

PRODUCT_DIR="install/mac/"

if [ ! -d "${PRODUCT_DIR}" ]; then
    mkdir -p "${PRODUCT_DIR}"
fi

mv "$DMG" "${PRODUCT_DIR}"

exit 0